Imports System.Console
Imports System.Security.Principal

Public Enum USER_PRIV As Integer
    USER_PRIV_GUEST = 0
    USER_PRIV_USER = 1
    USER_PRIV_POWERUSER = 2
    USER_PRIV_ADMIN = 3
End Enum

Module modWhoAmI
    Sub Main()
        Dim User As New WindowsPrincipal(WindowsIdentity.GetCurrent)
        Dim Recht, BenutzerName, RechnerName As String

        ' User.Identity.Name zerlegen in Benutzername und Rechnername.
        With User.Identity.Name
            BenutzerName = .Substring(.IndexOf("\") + 1)
            RechnerName = .Substring(0, .IndexOf("\"))
        End With

        ' Benutzerstatus abfragen.
        Select Case User_LogInState()
        Case USER_PRIV.USER_PRIV_ADMIN
            Recht = "Administrator"
        Case USER_PRIV.USER_PRIV_GUEST
            Recht = "Gast"
        Case USER_PRIV.USER_PRIV_POWERUSER
            Recht = "PowerUser"
        Case USER_PRIV.USER_PRIV_USER
            Recht = "User"
        End Select

        ' Ausgabe der Daten.
        WriteLine()
        WriteLine("Auskunft ber den angemeldeten Benutzer")
        WriteLine("---------------------------------------------")
        WriteLine("Rechnername : " & RechnerName)
        WriteLine("Benutzername: " & BenutzerName)
        WriteLine("Rechte      : " & Recht)
        WriteLine("---------------------------------------------")
    End Sub

    Public Function User_LogInState() As USER_PRIV
        ' Verweis auf aktuell angemeldeten Benutzer erstellen
        Dim oUser As New WindowsPrincipal(WindowsIdentity.GetCurrent)

        ' Anmeldestatus prfen
        If oUser.IsInRole(WindowsBuiltInRole.Administrator) Then
            ' Administrator
            Return (USER_PRIV.USER_PRIV_ADMIN)
        ElseIf oUser.IsInRole(WindowsBuiltInRole.PowerUser) Then
            ' PowerUser (Admin mit leicht eingeschrnkten Rechten)
            Return (USER_PRIV.USER_PRIV_POWERUSER)
        ElseIf oUser.IsInRole(WindowsBuiltInRole.User) Then
            ' User mit eingeschrnkten Rechten
            Return (USER_PRIV.USER_PRIV_USER)
        ElseIf oUser.IsInRole(WindowsBuiltInRole.Guest) Then
            ' Gast
            Return (USER_PRIV.USER_PRIV_GUEST)
        End If
    End Function
End Module
